//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%382983708930.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%382983708930.cm

//## begin module%382983708930.cp preserve=no
//## end module%382983708930.cp

//## Module: DataContainer%382983708930; Package specification
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/DataContainer.h

#ifndef DATACONTAINER_H
#define DATACONTAINER_H 1

//## begin module%382983708930.additionalIncludes preserve=no
//## end module%382983708930.additionalIncludes

//## begin module%382983708930.includes preserve=yes
#include <XSModel/GlobalContainer/TrashPtr.h>
//## end module%382983708930.includes

// xsTypes
#include <main/xsTypes.h>
// ctype
#include <ctype.h>
// map
#include <map>
// DataSet
#include <XSModel/Data/DataSet.h>
// Error
#include <XSUtil/Error/Error.h>
// Observer
#include <XSUtil/Utils/Observer.h>
// DataUtility
#include <XSModel/Data/DataUtility.h>
// XspecRegistry
#include <XSModel/DataFactory/XspecRegistry.h>
// DataSetTypes
#include <XSModel/GlobalContainer/DataSetTypes.h>
// Memento
#include <XSModel/GlobalContainer/Memento.h>
//## begin module%382983708930.declarations preserve=no
//## end module%382983708930.declarations

//## begin module%382983708930.additionalDeclarations preserve=yes
#include <set>
//## end module%382983708930.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    //## begin XSContainer::DataContainer%366ED73E24E0.preface preserve=yes
    //## end XSContainer::DataContainer%366ED73E24E0.preface

    //## Class: DataContainer%366ED73E24E0
    //	Singleton Class containing entire data structure.
    //	     No Copy, assignment or Equality operators.
    //	Implemented as a list of data groups.
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%3BB4DCBE0069;DataUtility { -> }
    //## Uses: <unnamed>%3BB4DD08009C;XSparse { -> }
    //## Uses: <unnamed>%3C34A4DA034A;DataSet { -> }
    //## Uses: <unnamed>%3C34A5F102D2;SpectralData { -> }

    class DataContainer : public Subject  //## Inherits: <unnamed>%3C72CDB400F1
    {
      //## begin XSContainer::DataContainer%366ED73E24E0.initialDeclarations preserve=yes
      //## end XSContainer::DataContainer%366ED73E24E0.initialDeclarations

      public:
        //## Class: NoSuchSpectrum%3BD9806603B8
        //	Exception to be thrown by lookup failures.
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        class NoSuchSpectrum : public YellowAlert  //## Inherits: <unnamed>%3BD980FF017A
        {
          public:
            //## Constructors (specified)
              //## Operation: NoSuchSpectrum%3BD9808E0254
              NoSuchSpectrum (int number);

          protected:
          private:
          private: //## implementation
        };

      private:
        //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.preface preserve=yes
        //## end XSContainer::DataContainer::DataMemento%41C0508501CB.preface

        //## Class: DataMemento%41C0508501CB; private
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        class DataMemento : public Memento  //## Inherits: <unnamed>%41C0636C0230
        {
          //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.initialDeclarations preserve=yes
          //## end XSContainer::DataContainer::DataMemento%41C0508501CB.initialDeclarations

          public:
            //## Constructors (generated)
              DataMemento(const DataMemento &right);

            //## Constructors (specified)
              //## Operation: DataMemento%41DC214B0073
              DataMemento (size_t size);

            //## Destructor (generated)
              virtual ~DataMemento();

            // Data Members for Class Attributes

              //## Attribute: spectra%41DAFCFA01A9
              //## begin XSContainer::DataContainer::DataMemento::spectra%41DAFCFA01A9.attr preserve=no  public: std::vector<SpectralData*> {U} 
              std::vector<SpectralData*> m_spectra;
              //## end XSContainer::DataContainer::DataMemento::spectra%41DAFCFA01A9.attr

            // Additional Public Declarations
              //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.public preserve=yes
              //## end XSContainer::DataContainer::DataMemento%41C0508501CB.public

          protected:
            // Additional Protected Declarations
              //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.protected preserve=yes
              //## end XSContainer::DataContainer::DataMemento%41C0508501CB.protected

          private:
            // Additional Private Declarations
              //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.private preserve=yes
              //## end XSContainer::DataContainer::DataMemento%41C0508501CB.private

          private: //## implementation
            // Additional Implementation Declarations
              //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.implementation preserve=yes
              //## end XSContainer::DataContainer::DataMemento%41C0508501CB.implementation

        };

        //## begin XSContainer::DataContainer::DataMemento%41C0508501CB.postscript preserve=yes
        //## end XSContainer::DataContainer::DataMemento%41C0508501CB.postscript

      public:
        //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.preface preserve=yes
        //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.preface

        //## Class: DataGroupHistory%4464F7070166
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        class DataGroupHistory 
        {
          //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.initialDeclarations preserve=yes
          //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.initialDeclarations

          public:
            //## Constructors (generated)
              DataGroupHistory();

            //## Destructor (generated)
              ~DataGroupHistory();


            //## Other Operations (specified)
              //## Operation: initOldArray%4464F8F200C4
              void initOldArray (size_t nGroups);

              //## Operation: swapHistory%4464F94B0374
              void swapHistory ();

              //## Operation: reassign%4464F97E015A
              void reassign (size_t oldVal, size_t newVal);

              //## Operation: getReassignment%4464FA010166
              size_t getReassignment (size_t oldVal) const;

              //## Operation: getOriginal%4464FA510311
              size_t getOriginal (size_t newVal) const;

              //## Operation: createReverseLookup%4468B11300B7
              void createReverseLookup (size_t nGroups);

              //## Operation: erase%446A473700B1
              void erase ();

              //## Operation: isEmpty%446A47480215
              bool isEmpty ();

            // Additional Public Declarations
              //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.public preserve=yes
              //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.public

          protected:
            // Additional Protected Declarations
              //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.protected preserve=yes
              //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.protected

          private:
            //## Constructors (generated)
              DataGroupHistory(const DataGroupHistory &right);

            //## Assignment Operation (generated)
              DataGroupHistory & operator=(const DataGroupHistory &right);

            // Additional Private Declarations
              //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.private preserve=yes
              //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.private

          private: //## implementation
            // Data Members for Class Attributes

              //## Attribute: reassignment%4464F8680130
              //## begin XSContainer::DataContainer::DataGroupHistory::reassignment%4464F8680130.attr preserve=no  private: std::vector<size_t> {U} 
              std::vector<size_t> m_reassignment;
              //## end XSContainer::DataContainer::DataGroupHistory::reassignment%4464F8680130.attr

              //## Attribute: reverseLookup%4464F8B2017C
              //## begin XSContainer::DataContainer::DataGroupHistory::reverseLookup%4464F8B2017C.attr preserve=no  private: std::vector<size_t> {U} 
              std::vector<size_t> m_reverseLookup;
              //## end XSContainer::DataContainer::DataGroupHistory::reverseLookup%4464F8B2017C.attr

            // Additional Implementation Declarations
              //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.implementation preserve=yes
              //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.implementation

        };

        //## begin XSContainer::DataContainer::DataGroupHistory%4464F7070166.postscript preserve=yes
        //## end XSContainer::DataContainer::DataGroupHistory%4464F7070166.postscript

        //## Destructor (generated)
          ~DataContainer();


        //## Other Operations (specified)
          //## Operation: Instance%913234100003;     C++
          static DataContainer* Instance ();

          //## Operation: plot%3860E0A1A710
          void plot (const string& dataSet, const string& args);

          //## Operation: addToList%39ECBC270085
          void addToList (DataSet* newDataSet);

          //## Operation: lookup%3A394BE40275
          SpectralData* lookup (size_t spectrumNumber) const;

          //## Operation: insertAndDelete%3A59E4A7000B
          std::vector<bool> insertAndDelete (DataUtility::recordList& records, size_t spectraDefined, bool preserve);

          //## Operation: clear%3A59E7EF00A5
          void clear ();

          //## Operation: deleteRange%3A5B830300BC
          void deleteRange (size_t begin, size_t end);

          //## Operation: deleteRange%3A5C9CAF002A
          void deleteRange (const std::vector<bool>& marked, bool preserve = false);

          //## Operation: dataArray%3BB206C301FF
          DataSet* dataArray (const string& name, size_t index) const;

          //## Operation: ignoreBadChannels%3BBC8029024B
          void ignoreBadChannels ();

          //## Operation: setChannels%3BBC8048014D
          void setChannels (bool value, IntegerArray& channelRange, IntegerArray& spectrumRange);

          //## Operation: setChannels%3BBC80C70262
          void setChannels (bool value, std::pair<Real,Real>& realRange, IntegerArray& spectrumRange);

          //## Operation: saveData%3F44E8A30362
          void saveData (std::ostream& s);

          //## Operation: dataArray%3C34A68000B1
          void dataArray (const std::string& name, DataSet* value);

          //## Operation: dataSetLookup%3CCEC1F8025B
          DataSet* dataSetLookup (size_t specNum, size_t& row) const;

          //## Operation: renumberPlotGroups%3D776125007E
          void renumberPlotGroups (size_t specNum, size_t high);

          //## Operation: resetDetectors%3E722E260330
          bool resetDetectors (const IntegerArray& spectra);

          //## Operation: saveIgnoredChannels%3F44EA27022F
          void saveIgnoredChannels (const DataSet* pDataSet, const SpectralData* pSData, std::ostringstream& ignoreInfo);

          //## Operation: dataArray%3FDF347F0106
          DataArray& dataArray ();

          //## Operation: verifySpectrumRange%4022AD9C0018
          void verifySpectrumRange ();

          //## Operation: CreateMemento%41C058700178
          Memento* CreateMemento ();

          //## Operation: SetMemento%41C0587E03D0
          void SetMemento (Memento const* m);

          //## Operation: moveToTrash%41CAFEBC00A0
          void moveToTrash (TrashCan::value_type ptr);

          //## Operation: emptyTrash%41D995C00374
          void emptyTrash (bool deleteObj = true);

          //## Operation: countPlotGroups%4203D7AA01C3
          void countPlotGroups ();

          //## Operation: adjustNumSources%4447E67D0028
          bool adjustNumSources (size_t addedSourceNum);

          //## Operation: determineDgSourceRelations%4469F3E70316
          void determineDgSourceRelations ();

          //## Operation: getLowestGroupForSource%447481EB0093
          size_t getLowestGroupForSource (size_t source) const;

          //## Operation: getNumberOfGroupsForSource%447F4B2F0228
          size_t getNumberOfGroupsForSource (size_t sourceNum) const;

          //## Operation: showData%46EFE56802C2
          void showData (bool isAll) const;

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: numberOfSpectra%3A379EE4010F
          size_t numberOfSpectra () const;
          void numberOfSpectra (size_t value);

          //## Attribute: numberOfGroups%3AAD190A011B
          size_t numberOfGroups () const;

          //## Attribute: numSourcesForSpectra%3CBF05D003D3
          size_t numSourcesForSpectra () const;

          //## Attribute: numberOfPlotGroups%3D76523A02B5
          size_t numberOfPlotGroups () const;

          //## Attribute: realRange%3FDDEF48027B
          const std::pair<Real,Real>& realRange () const;
          void setRealRange (const std::pair<Real,Real>& value);

          //## Attribute: dgHistory%4464FE410229
          DataContainer::DataGroupHistory& dgHistory ();

          //## Attribute: dgToSources%4469F40E005C
          const std::map<size_t, std::set<size_t> >& dgToSources () const;

          //## Attribute: sourceToDgs%446B6FFC0226
          const std::map<size_t, std::map<size_t,size_t> >& sourceToDgs () const;

        //## Get and Set Operations for Associations (generated)

          //## Association: XSModel::GlobalContainer::<unnamed>%3FDDEE3B010E
          //## Role: DataContainer::integerRange%3FDDEE3B032C
          const IntegerArray& integerRange () const;
          void setIntegerRange (const IntegerArray& value);

          //## Association: XSModel::GlobalContainer::<unnamed>%3FDDEE6A0362
          //## Role: DataContainer::spectrumRange%3FDDEE6C039E
          const IntegerArray& spectrumRange () const;
          void setSpectrumRange (const IntegerArray& value);

          //## Association: XSModel::GlobalContainer::DataSetTypes::<unnamed>%3C34A37B0076
          //## Role: DataContainer::dataArray%3C34A37B0337
          const DataArray& dataArray () const;

          //## Association: XSUser::Global::<unnamed>%3D7E60D2018A
          //## Role: DataContainer::plotGroupNums%3D7E60D30353
          //## Qualifier: index%3D7E64B903D4; size_t
          const IntegerArray& plotGroupNums () const;
          void setPlotGroupNums (const IntegerArray& value);
          int plotGroupNums (size_t index) const;
          void setPlotGroupNums (size_t index, int value);

      public:
        // Additional Public Declarations
          //## begin XSContainer::DataContainer%366ED73E24E0.public preserve=yes
          //## end XSContainer::DataContainer%366ED73E24E0.public

      protected:
        //## Constructors (generated)
          DataContainer();

        // Additional Protected Declarations
          //## begin XSContainer::DataContainer%366ED73E24E0.protected preserve=yes
          //## end XSContainer::DataContainer%366ED73E24E0.protected

      private:

        //## Other Operations (specified)
          //## Operation: enumerateSpectra%3A3A613500D4
          void enumerateSpectra ();

          //## Operation: removeNumberedSpectrum%3A3A8EFD00DE
          void removeNumberedSpectrum (size_t index, bool remove = false);

          //## Operation: renumberSpectra%3A5B84000278
          void renumberSpectra (size_t start, int offset = -1);

          //## Operation: enumerateGroups%3AAD18750162
          void enumerateGroups ();

          //## Operation: firstInPlotGroup%3D7CF1D700FB
          bool firstInPlotGroup (size_t specNum);

          //## Operation: examineResponse%402155EA0245
          static void examineResponse (const std::vector<const SpectralData*>& spectra, std::ostream& outFile, string& currentDir);

          //## Operation: bundleSpectra%4023CD7D0039
          void bundleSpectra (const IntegerArray& specRanges, std::vector<SpectralData*>& spectra) const;

          //## Operation: fixDataGroupGaps%40771815006C
          void fixDataGroupGaps ();

          //## Operation: examineArf%40FD5B8C026D
          static void examineArf (const std::vector<const SpectralData*>& spectra, std::ostream& outFile, string& currentDir);

          //## Operation: examineBackCorr%40FECBBA02E6
          static void examineBackCorr (const std::vector<const SpectralData*>& spectra, std::ostream& outFile, bool isBack, string& currentDir);

          //## Operation: bundleSpectra%41781FE400E8
          void bundleSpectra ();

          //## Operation: reinsertSpectrum%41ED5DC303E0
          void reinsertSpectrum (SpectralData* s);

          //## Operation: examineResponseFunctions%4A0D827200B5
          void examineResponseFunctions (const SpectralData* spectrum, std::ostringstream& respFuncs, std::ostringstream& respParLinks);

        // Additional Private Declarations
          //## begin XSContainer::DataContainer%366ED73E24E0.private preserve=yes
          //## end XSContainer::DataContainer%366ED73E24E0.private

      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: instance%36C1E003F5C4
          //## begin XSContainer::DataContainer::instance%36C1E003F5C4.attr preserve=no  private: static DataContainer* {U} 0
          static DataContainer* s_instance;
          //## end XSContainer::DataContainer::instance%36C1E003F5C4.attr

          //## begin XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.attr preserve=no  public: size_t {UM} 0
          mutable size_t m_numberOfSpectra;
          //## end XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.attr

          //## begin XSContainer::DataContainer::numberOfGroups%3AAD190A011B.attr preserve=no  public: size_t {UM} 1
          mutable size_t m_numberOfGroups;
          //## end XSContainer::DataContainer::numberOfGroups%3AAD190A011B.attr

          //## begin XSContainer::DataContainer::numSourcesForSpectra%3CBF05D003D3.attr preserve=no  public: size_t {UM} 0
          mutable size_t m_numSourcesForSpectra;
          //## end XSContainer::DataContainer::numSourcesForSpectra%3CBF05D003D3.attr

          //## begin XSContainer::DataContainer::numberOfPlotGroups%3D76523A02B5.attr preserve=no  public: size_t {U} 
          size_t m_numberOfPlotGroups;
          //## end XSContainer::DataContainer::numberOfPlotGroups%3D76523A02B5.attr

          //## begin XSContainer::DataContainer::realRange%3FDDEF48027B.attr preserve=no  public: std::pair<Real,Real> {U} std::pair<Real,Real>(0,0)
          std::pair<Real,Real> m_realRange;
          //## end XSContainer::DataContainer::realRange%3FDDEF48027B.attr

          //## Attribute: bundledSpectra%41781EFD0003
          //## begin XSContainer::DataContainer::bundledSpectra%41781EFD0003.attr preserve=no  private: std::vector<SpectralData*> {U} 
          std::vector<SpectralData*> m_bundledSpectra;
          //## end XSContainer::DataContainer::bundledSpectra%41781EFD0003.attr

          //## Attribute: trash%41CADA9203D9
          //## begin XSContainer::DataContainer::trash%41CADA9203D9.attr preserve=no  private: TrashCan {U} 
          TrashCan m_trash;
          //## end XSContainer::DataContainer::trash%41CADA9203D9.attr

          //## begin XSContainer::DataContainer::dgHistory%4464FE410229.attr preserve=no  public: DataContainer::DataGroupHistory {U} 
          DataContainer::DataGroupHistory m_dgHistory;
          //## end XSContainer::DataContainer::dgHistory%4464FE410229.attr

          //## begin XSContainer::DataContainer::dgToSources%4469F40E005C.attr preserve=no  public: std::map<size_t, std::set<size_t> > {U} 
          std::map<size_t, std::set<size_t> > m_dgToSources;
          //## end XSContainer::DataContainer::dgToSources%4469F40E005C.attr

          //## begin XSContainer::DataContainer::sourceToDgs%446B6FFC0226.attr preserve=no  public: std::map<size_t, std::map<size_t,size_t> > {U} 
          std::map<size_t, std::map<size_t,size_t> > m_sourceToDgs;
          //## end XSContainer::DataContainer::sourceToDgs%446B6FFC0226.attr

        // Data Members for Associations

          //## Association: XSModel::GlobalContainer::<unnamed>%3FDDEE3B010E
          //## begin XSContainer::DataContainer::integerRange%3FDDEE3B032C.role preserve=no  public: IntegerArray { -> 1VHgN}
          IntegerArray m_integerRange;
          //## end XSContainer::DataContainer::integerRange%3FDDEE3B032C.role

          //## Association: XSModel::GlobalContainer::<unnamed>%3FDDEE6A0362
          //## begin XSContainer::DataContainer::spectrumRange%3FDDEE6C039E.role preserve=no  public: IntegerArray { -> 1VHgN}
          IntegerArray m_spectrumRange;
          //## end XSContainer::DataContainer::spectrumRange%3FDDEE6C039E.role

          //## Association: XSModel::GlobalContainer::DataSetTypes::<unnamed>%3C34A37B0076
          //## begin XSContainer::DataContainer::dataArray%3C34A37B0337.role preserve=no  public: XSContainer::DataArray { -> 1VHgN}
          DataArray m_dataArray;
          //## end XSContainer::DataContainer::dataArray%3C34A37B0337.role

          //## Association: XSUser::Global::<unnamed>%3D7E60D2018A
          //## begin XSContainer::DataContainer::plotGroupNums%3D7E60D30353.role preserve=no  public: int { -> 1..nVHgN}
          IntegerArray m_plotGroupNums;
          //## end XSContainer::DataContainer::plotGroupNums%3D7E60D30353.role

        // Additional Implementation Declarations
          //## begin XSContainer::DataContainer%366ED73E24E0.implementation preserve=yes
          //## end XSContainer::DataContainer%366ED73E24E0.implementation

    };

    //## begin XSContainer::DataContainer%366ED73E24E0.postscript preserve=yes
    //## end XSContainer::DataContainer%366ED73E24E0.postscript

    // Class XSContainer::DataContainer::NoSuchSpectrum 

    // Class XSContainer::DataContainer::DataMemento 

    // Class XSContainer::DataContainer::DataGroupHistory 

    // Class XSContainer::DataContainer 

    //## Get and Set Operations for Class Attributes (inline)

    inline size_t DataContainer::numberOfSpectra () const
    {
      //## begin XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.get preserve=no
      return m_numberOfSpectra;
      //## end XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.get
    }

    inline void DataContainer::numberOfSpectra (size_t value)
    {
      //## begin XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.set preserve=no
      m_numberOfSpectra = value;
      //## end XSContainer::DataContainer::numberOfSpectra%3A379EE4010F.set
    }

    inline size_t DataContainer::numberOfGroups () const
    {
      //## begin XSContainer::DataContainer::numberOfGroups%3AAD190A011B.get preserve=no
      return m_numberOfGroups;
      //## end XSContainer::DataContainer::numberOfGroups%3AAD190A011B.get
    }

    inline size_t DataContainer::numSourcesForSpectra () const
    {
      //## begin XSContainer::DataContainer::numSourcesForSpectra%3CBF05D003D3.get preserve=no
      return m_numSourcesForSpectra;
      //## end XSContainer::DataContainer::numSourcesForSpectra%3CBF05D003D3.get
    }

    inline size_t DataContainer::numberOfPlotGroups () const
    {
      //## begin XSContainer::DataContainer::numberOfPlotGroups%3D76523A02B5.get preserve=no
      return m_numberOfPlotGroups;
      //## end XSContainer::DataContainer::numberOfPlotGroups%3D76523A02B5.get
    }

    inline const std::pair<Real,Real>& DataContainer::realRange () const
    {
      //## begin XSContainer::DataContainer::realRange%3FDDEF48027B.get preserve=no
      return m_realRange;
      //## end XSContainer::DataContainer::realRange%3FDDEF48027B.get
    }

    inline void DataContainer::setRealRange (const std::pair<Real,Real>& value)
    {
      //## begin XSContainer::DataContainer::setRealRange%3FDDEF48027B.set preserve=yes
      m_realRange.first = value.first;
      m_realRange.second = value.second;
      //## end XSContainer::DataContainer::setRealRange%3FDDEF48027B.set
    }

    inline DataContainer::DataGroupHistory& DataContainer::dgHistory ()
    {
      //## begin XSContainer::DataContainer::dgHistory%4464FE410229.get preserve=no
      return m_dgHistory;
      //## end XSContainer::DataContainer::dgHistory%4464FE410229.get
    }

    inline const std::map<size_t, std::set<size_t> >& DataContainer::dgToSources () const
    {
      //## begin XSContainer::DataContainer::dgToSources%4469F40E005C.get preserve=no
      return m_dgToSources;
      //## end XSContainer::DataContainer::dgToSources%4469F40E005C.get
    }

    inline const std::map<size_t, std::map<size_t,size_t> >& DataContainer::sourceToDgs () const
    {
      //## begin XSContainer::DataContainer::sourceToDgs%446B6FFC0226.get preserve=no
      return m_sourceToDgs;
      //## end XSContainer::DataContainer::sourceToDgs%446B6FFC0226.get
    }

    //## Get and Set Operations for Associations (inline)

    inline const IntegerArray& DataContainer::integerRange () const
    {
      //## begin XSContainer::DataContainer::integerRange%3FDDEE3B032C.get preserve=no
      return m_integerRange;
      //## end XSContainer::DataContainer::integerRange%3FDDEE3B032C.get
    }

    inline void DataContainer::setIntegerRange (const IntegerArray& value)
    {
      //## begin XSContainer::DataContainer::setIntegerRange%3FDDEE3B032C.set preserve=no
      m_integerRange = value;
      //## end XSContainer::DataContainer::setIntegerRange%3FDDEE3B032C.set
    }

    inline const IntegerArray& DataContainer::spectrumRange () const
    {
      //## begin XSContainer::DataContainer::spectrumRange%3FDDEE6C039E.get preserve=no
      return m_spectrumRange;
      //## end XSContainer::DataContainer::spectrumRange%3FDDEE6C039E.get
    }

    inline void DataContainer::setSpectrumRange (const IntegerArray& value)
    {
      //## begin XSContainer::DataContainer::setSpectrumRange%3FDDEE6C039E.set preserve=no
      m_spectrumRange = value;
      //## end XSContainer::DataContainer::setSpectrumRange%3FDDEE6C039E.set
    }

    inline const DataArray& DataContainer::dataArray () const
    {
      //## begin XSContainer::DataContainer::dataArray%3C34A37B0337.get preserve=no
      return m_dataArray;
      //## end XSContainer::DataContainer::dataArray%3C34A37B0337.get
    }

    inline const IntegerArray& DataContainer::plotGroupNums () const
    {
      //## begin XSContainer::DataContainer::plotGroupNums%3D7E60D30353.get preserve=no
      return m_plotGroupNums;
      //## end XSContainer::DataContainer::plotGroupNums%3D7E60D30353.get
    }

    inline void DataContainer::setPlotGroupNums (const IntegerArray& value)
    {
      //## begin XSContainer::DataContainer::setPlotGroupNums%3D7E60D30353.set preserve=no
      m_plotGroupNums = value;
      //## end XSContainer::DataContainer::setPlotGroupNums%3D7E60D30353.set
    }

    inline int DataContainer::plotGroupNums (size_t index) const
    {
      //## begin XSContainer::DataContainer::plotGroupNums%3D7E60D30353.qualget preserve=no
      return m_plotGroupNums[index];
      //## end XSContainer::DataContainer::plotGroupNums%3D7E60D30353.qualget
    }

} // namespace XSContainer

//## begin module%382983708930.epilog preserve=yes
//## end module%382983708930.epilog


#endif
